package requio.com_toolbars;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
	BALayout layout;
	static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "requio.com_toolbars", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}	
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "requio.com_toolbars", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
		initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
		processBA.raiseEvent(_activity, "activity_pause", activityBA.activity.isFinishing());
        processBA.setActivityPaused(true);
        mostCurrent = null;
	}
 @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
	
public anywheresoftware.b4a.keywords.Common __c = null;
public static double _aspect = 0;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button4 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button6 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button7 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button8 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panelbutt = null;
public anywheresoftware.b4a.objects.PanelWrapper _panelnext = null;
public anywheresoftware.b4a.objects.PanelWrapper _panelprev = null;
public anywheresoftware.b4a.objects.AnimationWrapper _ani = null;
public static double _aw = 0;
public static String  _activity_create(boolean _firsttime) throws Exception{
 BA.debugLineNum = 14;BA.debugLine="Activity.LoadLayout(\"layout_main\")";
mostCurrent._activity.LoadLayout("layout_main",mostCurrent.activityBA);
 BA.debugLineNum = 15;BA.debugLine="PanelButt.SendToBack";
mostCurrent._panelbutt.SendToBack();
 BA.debugLineNum = 16;BA.debugLine="PanelPrev.BringToFront";
mostCurrent._panelprev.BringToFront();
 BA.debugLineNum = 17;BA.debugLine="PanelNext.BringToFront";
mostCurrent._panelnext.BringToFront();
 BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 BA.debugLineNum = 21;BA.debugLine="aw = Activity.Width";
_aw = mostCurrent._activity.getWidth();
 BA.debugLineNum = 22;BA.debugLine="aspect = Activity.Height/aw";
_aspect = mostCurrent._activity.getHeight()/(double)_aw;
 BA.debugLineNum = 23;BA.debugLine="If aw > Activity.Height Then PanelNext.Left = aw - PanelNext.Width";
if (_aw>mostCurrent._activity.getHeight()) { 
mostCurrent._panelnext.setLeft((int)(_aw-mostCurrent._panelnext.getWidth()));};
 BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
 BA.debugLineNum = 74;BA.debugLine="ToastMessageShow(\"Button #1\",False)";
mostCurrent.__c.ToastMessageShow("Button #1",mostCurrent.__c.False);
 BA.debugLineNum = 75;BA.debugLine="End Sub";
return "";
}
public static String  _button2_click() throws Exception{
 BA.debugLineNum = 71;BA.debugLine="ToastMessageShow(\"Button #2\",False)";
mostCurrent.__c.ToastMessageShow("Button #2",mostCurrent.__c.False);
 BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _button3_click() throws Exception{
 BA.debugLineNum = 68;BA.debugLine="ToastMessageShow(\"Button #3\",False)";
mostCurrent.__c.ToastMessageShow("Button #3",mostCurrent.__c.False);
 BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}
public static String  _button4_click() throws Exception{
 BA.debugLineNum = 65;BA.debugLine="ToastMessageShow(\"Button #4\",False)";
mostCurrent.__c.ToastMessageShow("Button #4",mostCurrent.__c.False);
 BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _button5_click() throws Exception{
 BA.debugLineNum = 62;BA.debugLine="ToastMessageShow(\"Button #5\",False)";
mostCurrent.__c.ToastMessageShow("Button #5",mostCurrent.__c.False);
 BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _button6_click() throws Exception{
 BA.debugLineNum = 59;BA.debugLine="ToastMessageShow(\"Button #6\",False)";
mostCurrent.__c.ToastMessageShow("Button #6",mostCurrent.__c.False);
 BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _button7_click() throws Exception{
 BA.debugLineNum = 56;BA.debugLine="ToastMessageShow(\"Button #7\",False)";
mostCurrent.__c.ToastMessageShow("Button #7",mostCurrent.__c.False);
 BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _button8_click() throws Exception{
 BA.debugLineNum = 53;BA.debugLine="ToastMessageShow(\"Button #8\",False)";
mostCurrent.__c.ToastMessageShow("Button #8",mostCurrent.__c.False);
 BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
if (isFirst) {
main._process_globals();
} BA.debugLineNum = 6;BA.debugLine="Dim aspect As Double";
_aspect = 0;
 BA.debugLineNum = 7;BA.debugLine="Dim Button1,Button2,Button3,Button4,Button5,Button6,Button7,Button8 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button3 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button4 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button5 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button6 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button7 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._button8 = new anywheresoftware.b4a.objects.ButtonWrapper();
 BA.debugLineNum = 8;BA.debugLine="Dim PanelButt, PanelNext, PanelPrev As Panel";
mostCurrent._panelbutt = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._panelnext = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._panelprev = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 9;BA.debugLine="Dim Ani As Animation";
mostCurrent._ani = new anywheresoftware.b4a.objects.AnimationWrapper();
 BA.debugLineNum = 10;BA.debugLine="Dim aw As Double";
_aw = 0;
 BA.debugLineNum = 11;BA.debugLine="End Sub";
return "";
}
public static String  _panelnext_click() throws Exception{
 BA.debugLineNum = 39;BA.debugLine="PanelButt.Left = PanelButt.Left - aw";
mostCurrent._panelbutt.setLeft((int)(mostCurrent._panelbutt.getLeft()-_aw));
 BA.debugLineNum = 40;BA.debugLine="If aspect < 1 Then";
if (_aspect<1) { 
 BA.debugLineNum = 41;BA.debugLine="PanelButt.Left = -285dip * aspect";
mostCurrent._panelbutt.setLeft((int)(-mostCurrent.__c.DipToCurrent((int)(285))*_aspect));
 BA.debugLineNum = 42;BA.debugLine="Ani.InitializeTranslate(\"PanelButt\", aw * aspect, 0dip, 0dip, 0dip)";
mostCurrent._ani.InitializeTranslate(mostCurrent.activityBA,"PanelButt",(float)(_aw*_aspect),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))));
 BA.debugLineNum = 43;BA.debugLine="Else";
}else {
 BA.debugLineNum = 44;BA.debugLine="PanelButt.Left = -Activity.width";
mostCurrent._panelbutt.setLeft((int)(-mostCurrent._activity.getWidth()));
 BA.debugLineNum = 45;BA.debugLine="Ani.InitializeTranslate(\"PanelButt\", aw, 0dip, 0dip, 0dip)";
mostCurrent._ani.InitializeTranslate(mostCurrent.activityBA,"PanelButt",(float)(_aw),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))));
 BA.debugLineNum = 46;BA.debugLine="End If";
};
 BA.debugLineNum = 47;BA.debugLine="Ani.Duration = 500";
mostCurrent._ani.setDuration((long)(500));
 BA.debugLineNum = 48;BA.debugLine="Ani.RepeatCount = 0";
mostCurrent._ani.setRepeatCount((int)(0));
 BA.debugLineNum = 49;BA.debugLine="Ani.Start(PanelButt)";
mostCurrent._ani.Start((android.view.View)(mostCurrent._panelbutt.getObject()));
 BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _panelprev_click() throws Exception{
 BA.debugLineNum = 31;BA.debugLine="PanelButt.Left = 0dip";
mostCurrent._panelbutt.setLeft(mostCurrent.__c.DipToCurrent((int)(0)));
 BA.debugLineNum = 32;BA.debugLine="Ani.InitializeTranslate(\"PanelButt\", aw, 0dip, 0dip, 0dip)";
mostCurrent._ani.InitializeTranslate(mostCurrent.activityBA,"PanelButt",(float)(_aw),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))),(float)(mostCurrent.__c.DipToCurrent((int)(0))));
 BA.debugLineNum = 33;BA.debugLine="Ani.Duration = 50";
mostCurrent._ani.setDuration((long)(50));
 BA.debugLineNum = 34;BA.debugLine="Ani.RepeatCount = 0";
mostCurrent._ani.setRepeatCount((int)(0));
 BA.debugLineNum = 35;BA.debugLine="Ani.Start(PanelButt)";
mostCurrent._ani.Start((android.view.View)(mostCurrent._panelbutt.getObject()));
 BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 3;BA.debugLine="End Sub";
return "";
}
}
